#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=res\icon.ico
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_Run_Obfuscator=y
#Obfuscator_Parameters=/so
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.6.1
 Author:         Matwachich

 Script Function:


#ce ----------------------------------------------------------------------------

#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <GUIConstantsEx.au3>
#include <ListViewConstants.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <EditConstants.au3>
#Include <GuiListView.au3>
#include <GuiImageList.au3>

#include <RegSearch.au3>

; ==============================================================
; ### Variables
; ==============================================================
Global $__RegArray[2][2] = _
[["HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Run", _
"HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Run_Save"], _
["HKEY_CURRENT_USER\SOFTWARE\Microsoft\Windows\CurrentVersion\Run", _
"HKEY_CURRENT_USER\SOFTWARE\Microsoft\Windows\CurrentVersion\Run_Save"]]
Global $__CurrReg, $__i
; ==============================================================
; ### GUI
; ==============================================================
; Add Key GUI
Global $AddKey_GUI, $I_name, $I_cmd, $B_nav, $B_ok, $B_cancel
_AddKeyGUI()
; ---
Global $Main_GUI, $Lv_List, $C_reg, $C_sys, $B_switch
Global $ImgList, $img_on = @TempDir & "\gher4gze6g4der092.bmp", $img_off = @TempDir & "\gher4gze6g4der09.bmp"

#Region ### START Koda GUI section ### Form=
$Main_GUI  = GUICreate("RegAutoRun Manager", 625, 414, 387, 159, BitOR($WS_MAXIMIZEBOX,$WS_MINIMIZEBOX,$WS_SIZEBOX,$WS_THICKFRAME,$WS_SYSMENU,$WS_CAPTION,$WS_OVERLAPPEDWINDOW,$WS_TILEDWINDOW,$WS_POPUP,$WS_POPUPWINDOW,$WS_GROUP,$WS_TABSTOP,$WS_VISIBLE,$WS_BORDER,$WS_CLIPSIBLINGS))
; ---
FileInstall("res\off.bmp", $img_off, 1)
FileInstall("res\on.bmp", $img_on, 1)
$ImgList = _GuiImageList_Create(16, 16, 5)
_GUIImageList_AddBitmap($ImgList, $img_off)
_GUIImageList_AddBitmap($ImgList, $img_on)
OnAutoItExitRegister("__OnExit")
; ---
$Lv_List = GUICtrlCreateListView("Activ|Nom|Chemin d'acces", 12, 42, 601, 331, BitOR($LVS_REPORT,$LVS_SINGLESEL,$LVS_SHOWSELALWAYS,$WS_TABSTOP,$WS_VISIBLE,$WS_CHILD))
_GUICtrlListView_SetImageList($Lv_List, $ImgList, 1)
	GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 0, 45)
	GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 1, 100)
	GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 2, 450)
	GUICtrlSetResizing(-1, $GUI_DOCKLEFT+$GUI_DOCKRIGHT+$GUI_DOCKTOP+$GUI_DOCKBOTTOM+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
; ---
GUICtrlCreateLabel("Voir les entres:", 18, 12, 117, 20, BitOR($SS_NOTIFY,$WS_VISIBLE,$WS_CHILD))
	GUICtrlSetFont(-1, 10, 800, 0, "MS Sans Serif")
	GUICtrlSetResizing(-1, $GUI_DOCKLEFT+$GUI_DOCKTOP+$GUI_DOCKHCENTER+$GUI_DOCKVCENTER+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
;$C_sys = GUICtrlCreateCheckbox("Voire les entres Systmes", 12, 384, 145, 17)
;	GUICtrlSetResizing(-1, $GUI_DOCKLEFT+$GUI_DOCKBOTTOM+$GUI_DOCKHCENTER+$GUI_DOCKVCENTER+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
;	GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlCreateLabel("RegAutoRun Manager", 498, 378, 111, 17, BitOR($SS_NOTIFY,$WS_VISIBLE,$WS_CHILD))
	GUICtrlSetResizing(-1, $GUI_DOCKRIGHT+$GUI_DOCKBOTTOM+$GUI_DOCKHCENTER+$GUI_DOCKVCENTER+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
GUICtrlCreateLabel("By Matwachich", 528, 396, 77, 17, BitOR($SS_NOTIFY,$WS_VISIBLE,$WS_CHILD))
	GUICtrlSetResizing(-1, $GUI_DOCKRIGHT+$GUI_DOCKBOTTOM+$GUI_DOCKHCENTER+$GUI_DOCKVCENTER+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
; ---
$C_reg = GUICtrlCreateCombo("", 138, 12, 151, 25, BitOR($CBS_DROPDOWN,$CBS_AUTOHSCROLL,$WS_TABSTOP,$WS_VISIBLE,$WS_CHILD))
	GuiCtrlSetData(-1, "De l'utilisateur|Globales", "De l'utilisateur")
	GUICtrlSetResizing(-1, $GUI_DOCKLEFT+$GUI_DOCKTOP+$GUI_DOCKHCENTER+$GUI_DOCKVCENTER+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
$B_add = GUICtrlCreateButton("Ajouter", 378, 12, 75, 19, BitOR($BS_NOTIFY,$WS_GROUP,$WS_TABSTOP,$WS_VISIBLE,$WS_CHILD))
	GUICtrlSetResizing(-1, $GUI_DOCKRIGHT+$GUI_DOCKTOP+$GUI_DOCKHCENTER+$GUI_DOCKVCENTER+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
$B_del = GUICtrlCreateButton("Supprimer", 456, 12, 75, 19, BitOR($BS_NOTIFY,$WS_GROUP,$WS_TABSTOP,$WS_VISIBLE,$WS_CHILD))
	GUICtrlSetResizing(-1, $GUI_DOCKRIGHT+$GUI_DOCKTOP+$GUI_DOCKHCENTER+$GUI_DOCKVCENTER+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
$B_switch = GUICtrlCreateButton("On/Off", 534, 12, 75, 19, BitOR($BS_NOTIFY,$WS_GROUP,$WS_TABSTOP,$WS_VISIBLE,$WS_CHILD))
	GUICtrlSetResizing(-1, $GUI_DOCKRIGHT+$GUI_DOCKTOP+$GUI_DOCKHCENTER+$GUI_DOCKVCENTER+$GUI_DOCKWIDTH+$GUI_DOCKHEIGHT)
; ---
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

_EnumRegKeys()

; ==============================================================
; ### Functions
; ==============================================================
Func _EnumRegKeys()
	_GUICtrlListView_BeginUpdate($Lv_list)
	; ---
	_GUICtrlListView_DeleteAllItems(GuiCtrlGetHandle($Lv_list))
	; ---
	_GetCurrentReg()
	; ---
	$__i = 0
	Local $list = _Reg_Search($__RegArray[$__CurrReg][0])
	If IsArray($list) Then
		For $i = 1 To $list[0][0]
			_KeyToLv($list[$i][0], $list[$i][1], 1)
		Next
	EndIf
	; ---
	_EnumDesactivees($__RegArray[$__CurrReg][1])
	; ---
	_GUICtrlListView_EndUpdate($Lv_list)
EndFunc

Func _EnumDesactivees($sReg)
	Local $list = _Reg_Search($sReg)
	If IsArray($list) Then
		For $i = 1 To $list[0][0]
			_KeyToLv($list[$i][0], $list[$i][1], 0)
		Next
	EndIf
EndFunc

Func _SwitchKey()
	Local $read = _GUICtrlListView_GetItemTextString($Lv_list, -1)
	If $read = "||" Then Return
	; ---
	Local $split = StringSplit($read, "|")
	Local $name = $split[2], $val = $split[3]
	Switch $split[1]
		Case "On"
			RegWrite($__RegArray[$__CurrReg][1], $name, _RegGetType($__RegArray[$__CurrReg][0], $split[2]), $val)
			RegDelete($__RegArray[$__CurrReg][0], $name)
		Case "Off"
			RegWrite($__RegArray[$__CurrReg][0], $name, _RegGetType($__RegArray[$__CurrReg][1], $split[2]), $val)
			RegDelete($__RegArray[$__CurrReg][1], $name)
	EndSwitch
	_EnumRegKeys()
EndFunc

Func _DeleteKey()
	If MsgBox(20, "Confirmation", "Voulez-vous vraiment supprimer cet entre?" & @CRLF & "(Cette opration est irrversible)") = 7 Then Return
	Local $read = _GUICtrlListView_GetItemTextString($Lv_list, -1)
	If $read = "||" Then Return
	; ---
	ConsoleWrite($read & @CRLF)
	Local $split = StringSplit($read, "|")
	Local $name = $split[2], $val = $split[3]
	Switch $split[1]
		Case "On"
			RegDelete($__RegArray[$__CurrReg][0], $name)
		Case "Off"
			RegDelete($__RegArray[$__CurrReg][1], $name)
	EndSwitch
	_EnumRegKeys()
EndFunc

Func _AddKey()
	GuiSetState(@SW_SHOW, $AddKey_GUI)
	GuiSetState(@SW_DISABLE, $Main_GUI)
	; ---
	Local $nMsg, $valider, $tmp
	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE, $B_cancel
				ExitLoop
			Case $B_nav
				$tmp = FileOpenDialog("Choisir un fichier", @DesktopDir, "All (*.*)", 3)
				If @error Then ContinueCase
				GuiCtrlSetData($I_cmd, $tmp)
			Case $B_OK
				If GuiCtrlRead($I_name) = "" Or GuiCtrlRead($I_cmd) = "" Then ContinueCase
				$valider = 1
				ExitLoop
		EndSwitch
	WEnd
	; ---
	If $valider Then
		RegWrite($__RegArray[$__CurrReg][0], GuiCtrlRead($I_name), "REG_SZ", GuiCtrlRead($I_cmd))
		_EnumRegKeys()
	EndIf
	; ---
	GuiSetState(@SW_ENABLE, $Main_GUI)
	GuiSetState(@SW_HIDE, $AddKey_GUI)
EndFunc

; ==============================================================
; ### Main-Loop
; ==============================================================
While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit
		Case $C_reg
			_EnumRegKeys()
		Case $B_switch
			_SwitchKey()
		Case $B_del
			_DeleteKey()
		Case $B_add
			_AddKey()

	EndSwitch
WEnd

; ==============================================================
; ### Internals
; ==============================================================
Func _KeyToLv($sKey, $sValue, $iActive)
	Local $item
	Switch $iActive
		Case True
			_GUICtrlListView_AddItem($Lv_list, "On", 1)
		Case False
			_GUICtrlListView_AddItem($Lv_list, "Off", 0)
	EndSwitch
	_GuiCtrlListView_AddSubItem($Lv_list, $__i, $sKey, 1)
	_GuiCtrlListView_AddSubItem($Lv_list, $__i, $sValue, 2)
	$__i += 1
EndFunc

Func _AddKeyGUI()
	#Region ### START Koda GUI section ### Form=
	$AddKey_GUI = GUICreate("Ajouter une entre", 463, 115, 394, 253)
	GUICtrlCreateLabel("Nom de l'entre:", 12, 60, 97, 17, BitOR($SS_NOTIFY,$WS_VISIBLE,$WS_CHILD))
	GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
	GUICtrlCreateLabel("Ligne de commande:", 12, 12, 121, 17, BitOR($SS_NOTIFY,$WS_VISIBLE,$WS_CHILD))
	GUICtrlSetFont(-1, 8, 800, 0, "MS Sans Serif")
	$I_cmd = GUICtrlCreateInput("", 12, 30, 433, 21, BitOR($ES_AUTOHSCROLL,$WS_TABSTOP,$WS_VISIBLE,$WS_CHILD))
	$B_nav = GUICtrlCreateButton("", 414, 54, 27, 25, BitOR($BS_NOTIFY,$WS_GROUP,$WS_TABSTOP,$WS_VISIBLE,$WS_CHILD,$BS_ICON))
		GuiCtrlSetImage(-1, "shell32.dll", -4, 0)
	$I_name = GUICtrlCreateInput("", 12, 78, 121, 21, BitOR($ES_AUTOHSCROLL,$WS_TABSTOP,$WS_VISIBLE,$WS_CHILD))
	$B_ok = GUICtrlCreateButton("Valider", 174, 72, 75, 25, BitOR($BS_NOTIFY,$WS_GROUP,$WS_TABSTOP,$WS_VISIBLE,$WS_CHILD))
	$B_cancel = GUICtrlCreateButton("Annuler", 258, 72, 75, 25, BitOR($BS_NOTIFY,$WS_GROUP,$WS_TABSTOP,$WS_VISIBLE,$WS_CHILD))
	#EndRegion ### END Koda GUI section ###
EndFunc

Func _GetCurrentReg()
	Switch GuiCtrlRead($C_reg)
		Case "De l'utilisateur"
			$__CurrReg = 1
		Case "Globales"
			$__CurrReg = 0
	EndSwitch
EndFunc

Func _RegGetType($key, $name)
	Local $ret
	RegRead($key, $name)
	Switch @extended
		Case 1
			$ret = "REG_SZ"
		Case 7
			$ret = "REG_MULTI_SZ"
		Case 2
			$ret = "REG_EXPAND_SZ"
		Case 4
			$ret = "REG_DWORD"
		;Case 
		;	$ret = "REG_QWORD"
		Case 3
			$ret = "REG_BINARY"
	EndSwitch
	Return $ret
EndFunc

Func __OnExit()
	FileDelete($img_on)
	FileDelete($img_off)
EndFunc
